CoRE Target Attributes Registry
RFC 0000
Carsten Bormann
Universität Bremen TZI
Postfach 330440
Bremen
D-28359
Germany
+49-421-218-63921
cabo@tzi.org
December 2023
art
core
The Constrained RESTful Environments (CoRE) specifications apply Web technologies to constrained environments. One important such technology is Web Linking (RFC 8288), which CoRE specifications use as the basis for a number of discovery protocols, such as the Link Format (RFC 6690) in CoAP's Resource Discovery Protocol (Section 7.2 of RFC7252) and the Resource Directory (RD, RFC 9176).
Web Links can have target attributes, the names of which are not generally coordinated by the Web Linking specification (Section 2.2 of RFC 8288). This document introduces an IANA registry for coordinating names of target attributes when used in CoRE. It updates the RD Parameters IANA Registry created by RFC 9176 to coordinate with this registry.
About This Document
Status information for this document may be found at https://datatracker.ietf.org/doc/draft-ietf-core-target-attr/.
Discussion of this document takes place on the core Working Group mailing list (mailto:core@ietf.org), which is archived at https://mailarchive.ietf.org/arch/browse/core/. Subscribe at https://www.ietf.org/mailman/listinfo/core/.
Source for this draft and an issue tracker can be found at https://github.com/core-wg/core-target-attr.
Introduction
The Constrained RESTful Environments (CoRE) specifications apply Web technologies to constrained environments. One important such technology is Web Linking [RFC8288], which CoRE specifications use as the basis for a number of discovery protocols, such as the Link Format [RFC6690] in CoAP's Resource Discovery Protocol (Section 7.2 of [RFC7252]) and the Resource Directory [RFC9176].
Web Links can have target attributes. The original Web Linking specification (Section 3 of [RFC5988]) did not attempt to coordinate names of target attributes except for providing common target attributes for use in the Link HTTP header. The current revision of that specification clarifies (Section 2.2 of [RFC8288]):
This specification does not attempt to coordinate the name of target attributes, their cardinality, or use. Those creating and maintaining serialisations SHOULD coordinate their target attributes to avoid conflicts in semantics or syntax and MAY define their own registries of target attributes.
This document introduces an IANA registry for coordinating names of target attributes when used in CoRE, with specific instructions for the Designated Expert for this registry (Section 2.1). It updates the RD Parameters IANA Registry created by [RFC9176] to coordinate with this registry.
With a registry now available, registration of target attributes is strongly encouraged. The incentive is that an unregistered attribute name might be registered with a different meaning at any time.
Terminology
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
IANA Considerations
This specification creates a new Target Attributes registry in the "Constrained RESTful Environments (CoRE) Parameters" registry group [IANA.core-parameters], with the policy "Expert Review" (Section 4.5 of [RFC8126]).
Instructions for the Designated Expert
The expert is requested to guide the registrant towards reasonably short target attribute names where the shortness will help conserve resources in constrained systems, but also to be frugal in the allocation of very short names, keeping them in reserve for applications that are likely to enjoy wide use and can make good use of their shortness.
The expert is also instructed to direct the registrant to provide a specification (Section 4.6 of [RFC8126]), but can make exceptions, for instance when a specification is not available at the time of registration but is likely forthcoming.
Any questions or issues that might interest a wider audience might be raised by the expert on the core-parameters@ietf.org mailing list for a time-limited discussion. This might include security considerations, or opportunities for orchestration, e.g., when different names with similar intent are being or could be registered.
If the expert becomes aware of target attributes that are deployed and in use, they may also initiate a registration on their own if they deem such a registration can avert potential future collisions.
Structure of Entries
Each entry in the registry must include:
Attribute Name:
a lower case ASCII [RFC0020] string that starts with a letter and can contain digits and hyphen-minus characters afterward ([a-z][-a-z0-9]*). (Note that [RFC8288] requires target attribute names to be interpreted in a case-insensitive way; the restriction to lower case here ensures that they are registered in a predictable form).
Brief description:
a brief description
Change Controller:
see Section 2.3 of [RFC8126]
Reference:
a reference document that provides a description of the target attribute, including the semantics for when the target attribute appears more than once in a link.
Initial Entries
Initial entries in this registry are listed in Table 1.
Initial Entries in the Target Attributes Registry
Attribute Name | Brief description | Change Controller | Reference
href | reserved (not useful as target attribute name) | IETF | [RFC6690]
anchor | reserved (not useful as target attribute name) | IETF | [RFC6690]
rel | reserved (not useful as target attribute name) | IETF | [RFC6690]
rev | reserved (not useful as target attribute name) | IETF | [RFC6690]
hreflang | (Web Linking) | IETF | [RFC8288]
media | (Web Linking) | IETF | [RFC8288]
title | (Web Linking) | IETF | [RFC8288]
type | (Web Linking) | IETF | [RFC8288]
rt | resource type | IETF | Section 3.1 of [RFC6690]
if | interface description | IETF | Section 3.2 of [RFC6690]
sz | maximum size estimate | IETF | Section 3.3 of [RFC6690]
ct | Content-Format hint | IETF | Section 7.2.1 of [RFC7252]
obs | observable resource | IETF | Section 6 of [RFC7641]
hct | HTTP-CoAP URI mapping template | IETF | Section 5.5 of [RFC8075]
osc | hint: resource only accessible using OSCORE | IETF | Section 9 of [RFC8613]
ep | Endpoint Name (with rt="core.rd-ep") | IETF | Section 9.3 of [RFC9176]
d | Sector (with rt="core.rd-ep") | IETF | Section 9.3 of [RFC9176]
base | Registration Base URI (with rt="core.rd-ep") | IETF | Section 9.3 of [RFC9176]
et | Endpoint Type (with rt="core.rd-ep") | IETF | Section 9.3 of [RFC9176]
A number of names are reserved as they are used for parameters in links other than target attributes. A further set of target attributes is predefined in [RFC8288] and is imported into this registry.
Section 9.3 of [RFC9176] created the "RD Parameters" IANA registry. This document requests IANA to add the following note to that registry:
Note: In accordance with RFC 0000, all entries with the "A" flag set, including new ones, MUST also be registered in the "Target Attributes" registry [IANA.core-parameters].
Security considerations
The security considerations of [RFC8288] apply, as do those of the discovery specifications [RFC6690], [RFC7252], and [RFC9176].
References
Normative References
[IANA.core-parameters]

Constrained RESTful Environments (CoRE) Parameters
IANA
Informative References
[RFC8288]
[RFC6690]
[RFC7252]
[RFC9176]
[RFC5988]
[RFC2119]
[RFC8174]
[RFC8126]
[RFC0020]
[RFC7641]
[RFC8075]
[RFC8613]
Acknowledgements
The CoRE WG had been discussing setting up a registry for target attributes since the final touches were made on [RFC6690]. The update of the Web Linking specification to [RFC8288] provided the formal setting, but it took until Jaime Jiménez provided the set of initial registrations to generate a first version of this specification. The current version addresses additional input and working group last call comments by Esko Dijk, Marco Tiloca, Thomas Fossati, and Mohamed Boucadair, as well as area director review comments from Rob Wilton.
Contributors
Jaime Jiménez
Ericsson
jaime@iki.fi
Jaime provided the list of initial registrations.